LeetCode Search for a Range

题目:

Given a sorted array of integers, find the starting and ending position of a given target value.

Your algorithm's runtime complexity must be in the order of O(log n).

If the target is not found in the array, return [-1, -1].

For example,
Given [5, 7, 7, 8, 8, 10] and target value 8,
return [3, 4].

题意:

就是给定一个已经排好序的数组和一个指定的数,然后需要判断这个数是否在这个数组中,如果在这个数组中,那么需要指出含有这个数的数组的起始位置,否则就是返回[-1,-1]。题目很好理解,而且因为看到了已经排好序,所以考虑用二分搜索,这是关键,找出具体的那个数的位置,然后找到后还得看这个数的位置,如果是在开头,那么只要从后面开始找,看看有没有了;如果是在结尾,那么向前找,如果是在中间,则采用夹逼,从两头开始夹,看是否有相同的,然后再返回。思路还是很简单的,主要是二分搜索法的应用,要回熟练地写,二分搜索法的关键是,一开始要判断start <= end,这是用递归做二分搜索的关键。

public int[] searchRange(int[] nums,int target)
	{
		int[] result = new int[2];
		result[0] = -1;
		result[1] = -1;
		int length = nums.length;
		if(nums == null || nums.length == 0)
		{
			result[0] = -1;
			result[1] = -1;
			return result;
		}
		if(nums.length == 1 && nums[0] == target)
		{
			result[0] = 0;
			result[1] = 0;
			return result;
		}
		else if(nums.length == 1 && nums[0] != target)
		{
			result[0] = -1;
			result[1] = -1;
			return result;
		}
		int num = binarySearch(nums,target,0,length - 1);
		if(num == -1)
		{
			result[0] = -1;
			result[1] = -1;
		}
		else
		{
			if(num == 0)
			{
				int i = 0;
				for(i = 0; i < length; i++)
				{
					if(nums[i] != nums[num])
						break;
				}
				result[0] = num;
				result[1] = i - 1;
			}
			else if(num == length - 1)
			{
				int i = length - 1;
				while(i >= 0)
				{
					if(nums[i] != nums[num])
						break;
					i--;
				}
				i++;
				result[0] = i;
				result[1] = num;
			}
			else
			{
				int i = num;
				int j = num;
				while(i <= length - 1)
				{
					if(nums[i] != nums[num])
						break;
					i++;
				}
				while(j >= 0)
				{
					if(nums[j] != nums[num])
						break;
					j--;
				}
				j++;
				i--;
				result[0] = j;
				result[1] = i;
			}
		}
		return result;
	}
	public int binarySearch(int[] nums,int target,int start,int end)
	{
	    if(start <= end)
		{
		    int mid = (start + end) / 2;
    		if(nums[mid] == target)
    			return mid;
    		if(nums[mid] < target)
    			return binarySearch(nums,target,mid + 1,end);
    		else if(nums[mid] > target)
    			return binarySearch(nums,target,start,mid - 1);
		}
		return -1;
	}


Leetcode 443题是关于压缩字符串的问题。题目要求我们对给定的字符数组进行原地修改,使其变为压缩后的形式,并返回压缩后的数组长度。 解题的思路是使用双指针来遍历数组。指针j从第二个元素开始遍历,判断当前元素是否与前一个元素相同。如果相同,则计数器count加1;如果不同,则需要将计数的字符放在后面,并更新指针i的位置。当计数器count大于1时,需要将count转换为字符串,并依次放在后面的位置上。最后返回指针i的位置,即为压缩后的数组长度。 下面是示例代码: ``` class Solution(object): def compress(self, chars): n = len(chars) count = 1 i = 0 for j in range(1, n): if j < n and chars[j-1 == chars[j]: count += 1 else: chars[i = chars[j-1] i += 1 if count > 1: for m in str(count): chars[i = m i += 1 count = 1 return i ``` 这样就可以实现对给定字符数组的原地压缩,并返回压缩后的数组长度。<span class="em">1</span><span class="em">2</span><span class="em">3</span> #### 引用[.reference_title] - *1* *2* [LeetCode第 443 题:压缩字符串(C++)](https://blog.csdn.net/qq_32523711/article/details/109106406)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] - *3* [LeetCode刷题记录——第443题(压缩字符串)](https://blog.csdn.net/bulo1025/article/details/86561588)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值